:- import find_components/1, find_forward_dependencies/1, find_backward_dependencies/1, 
	find_answers/1
from tables.

:- import thread_create/2, thread_join/2 from thread.

test:- 
	thread_create(test1,One),
	thread_create(test1,Two),
	thread_create(test1,Three),
	thread_create(test1,Four),
	thread_create(test1,Five),
	thread_create(test1,Six),
	thread_join([One,Two,Three,Four,Five,Six],_Exits),
	writeln('finished parallel abolish cascade pred concurrent').

test1:- p1(_,_,_),p1(a,b,_),s,abolish_table_pred(undefined),fail.
test1:- get_residual(p1(A,B,C),D),writeln(get_residual(p1(A,B,C),D)),fail.
test1:- get_residual(s,F),writeln(get_residual(s,F)),fail.
test1:- p1(_,_,_),p1(_,_,_),abolish_table_pred(undefined),fail.
test1:- get_residual(p1(A,B,C),D),writeln(get_residual(p1(A,B,C),D)),fail.
test1:- get_residual(s,F),writeln(get_residual(s,F)),fail.
test1:- p1(_,_,_),s,abolish_table_pred(undefined),abolish_table_pred(p1(_,_,_)),fail.
test1:- get_residual(p1(A,B,C),D),writeln(get_residual(p1(A,B,C),D)),fail.
test1:- get_residual(s,F),writeln(get_residual(s,F)),fail.
%test1:- p1(_,_,_),p1(_,_,_),s,abolish_table_pred(undefined,[abolish_tables_singly]),fail.
%test1:- get_residual(p1(A,B,C),D),writeln(get_residual(p1(A,B,C),D)),fail.
%test1:- get_residual(s,F),writeln(get_residual(s,F)),fail.
test1:- p2(_,_,_),abolish_table_pred(r2(_,_,_)),abolish_table_pred(r3(_,_,_)),fail.
test1:- get_residual(p2(A,B,C),F),writeln(get_residual(p2(A,B,C),F)),fail.
test1:- get_residual(r2(A,B,C),F),writeln(get_residual(r2(A,B,C),F)),fail.
test1:- get_residual(r3(A,B,C),F),writeln(get_residual(r3(A,B,C),F)),fail.
test1.

:- table p1/3, r1/3.
p1(X,Y,Z):- r1(X,Y,Z).

r1(a,b,c):- undefined.
r1(a,b,d):- undefined.
r1(a,c,c):- undefined.
r1(a,c,d):- undefined.
r1(b,c,d):- undefined.
r1(b,c,e):- undefined.
r1(c,c,e):- undefined.
r1(d,c,e):- undefined.
r1(3,c,e):- undefined.
r1(f,c,e):- undefined.
r1(g,c,e):- undefined.
r1(h,c,e):- undefined.
r1(i,c,e):- undefined.

:- table s/0,t/0.
s:- tnot(t).

t:- tnot(undefined).

:- table p2/3,  r2/3,  r3/3.
p2(X,Y,Z):- r2(X,Y,Z).
p2(X,Y,Z):- r3(X,Y,Z).

r2(a,b,c):- undefined.
r2(a,b,d):- undefined.
r2(a,c,c):- undefined.
r2(a,c,d):- undefined.
r2(b,c,d):- undefined.
r2(b,c,e):- undefined.
r2(c,c,e):- undefined.

r3(d,c,e):- undefined.
r3(3,c,e):- undefined.
r3(f,c,e):- undefined.
r3(g,c,e):- undefined.
r3(h,c,e):- undefined.
r3(i,c,e):- undefined.

ta3:- p2(_,_,_),abolish_table_call(r2(_,_,_)),abolish_table_call(r3(_,_,_)).
