
:- import close_open_tables/1 from machine.
:- import xsb_error_get_tag/2 from error_handler.

test:- test_failure,fail.
test:-  p(7,Y),writeln(on_failure(p(7,Y))),fail.
test:- catch(test_error,E,(xsb_error_get_tag(E,X),writeln(error_caught(X)))),fail.
test:- close_open_tables(non_memory_error), fail.
test.

test_failure:- 
	abolish_all_tables,
	set_prolog_flag(max_table_answer_action,failure),
	p(7,_Y).

test_error:- 
	abolish_all_tables,
	set_prolog_flag(max_table_answer_action,error),
	p([4,3],_Y).

:- table p/2 as answer_abstract(4).
p(Y,f(X)):- p(Y,X).
p(_,a).

% not testing because warnings can't be compared as they use variable addresses.

test_warn:- 
	abolish_all_tables,
	set_prolog_flag(max_table_answer_action,warning),
	p_w([1,a],_X).

:- table p_w/2 as answer_abstract(4).
p_w(Y,f(f(f(f(f(X)))))).
p_w(_,a).
